SystemOrganization addCategory: #SwazooSpike!

SwazooResource subclass: #S2JWebApp
	instanceVariableNames: ''
	classVariableNames: 'globalResponseId isServing responseContent sessions'
	poolDictionaries: ''
	category: 'SwazooSpike'!

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
applicationPath

	^ '/app'.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/7/2010 18:05'!
defaultMillisecondsToWait

	^ 100.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/2/2010 11:27'!
defaultPort

	^ 8887! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 12:47'!
defaultResponseId

	^ 0.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 13:51'!
defaultSuccessResponse

	^ 'success'! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
globalResponseId
	^ globalResponseId! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/1/2010 22:44'!
globalResponseId: anObject
	globalResponseId := anObject! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
increaseResponseId

	self globalResponseId: self globalResponseId + 1.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:47'!
inputPath

	^ '/put'.! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
isInstalled

	^ self site notNil.! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/7/2010 10:33'!
isServing
	^ isServing! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/7/2010 10:33'!
isServing: anObject
	isServing := anObject! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/6/2010 12:44'!
prepareSite

	| site |
	site := SwazooSite newNamed: self siteName.
	site
		host: '*'
		ip: '*'
		port: self defaultPort;
		addResource: (self uriPattern: '/').
	self sessions: Dictionary new.
	^ site! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/2/2010 11:28'!
removeSite

	SwazooServer singleton removeSite: self site.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/6/2010 15:12'!
replacementDictionary

	^ Dictionary new
		at: '<' put: '%3C';
		at: '>' put: '%3E';
		yourself.! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:18'!
resetContent

	self
		globalResponseId: 0;
		responseContent: nil.
	self allInstances do: [ : each  | each localResponseId: 0 ]. ! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:28'!
responseContent
	^responseContent
! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'SW 12/1/2010 16:15'!
responseContent: anObject
	responseContent := anObject! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/6/2010 11:41'!
sessions
	^ sessions! !

!S2JWebApp class methodsFor: 'accessing' stamp: 'HK 12/6/2010 11:41'!
sessions: anObject
	sessions := anObject! !

!S2JWebApp class methodsFor: 'setup' stamp: 'HK 12/1/2010 21:32'!
site

	^ SwazooServer singleton siteNamed: self siteName.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 21:39'!
siteName

	^ 'S2JWebApp'.! !

!S2JWebApp class methodsFor: 'launch' stamp: 'HK 12/7/2010 10:35'!
startWebApp

	self isInstalled ifFalse: [ self prepareSite ].
	self isServing: true.
	self site start.
! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/7/2010 16:49'!
toggleIsServing

	self isServing: self isServing not! !

!S2JWebApp class methodsFor: 'convenience' stamp: 'HK 12/2/2010 13:48'!
updateResponseContentWith: content

	self responseContent: content.
	self increaseResponseId.! !

!S2JWebApp class methodsFor: 'configuration' stamp: 'HK 12/1/2010 20:45'!
xmlPath

	^ '/xml'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/6/2010 13:39'!
answerContent: data withType: aString

	| response |
	response := HTTPResponse ok.
	^ response
		contentType: aString;
		entity: data;
		yourself.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:41'!
answerCreated

	^ HTTPResponse new code: 201.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:53'!
answerForbidden

	^ HTTPResponse forbidden.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 11:53'!
answerNoContent

	^ HTTPResponse new code: 204.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 13:42'!
answerTo: aRequest 

	| resource response |
		
	resource := self identifierOf: aRequest.
	response := self handleRequest: aRequest for: resource.
	
	(self hasSession: aRequest) ifFalse: [ self startSessionWith: response.].
	
	^ response.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 13:42'!
answerWebsite

	^ self
		answerContent: self renderWebsite
		withType: 'text/html'.! !

!S2JWebApp methodsFor: 'responding' stamp: 'HK 12/7/2010 13:45'!
answerXmlDataTo: aRequest

	self increaseLocalResponseIdFor: aRequest.
	^ self
		answerContent: (self wrapUpAsXml: self class responseContent)
		withType: 'text/xml'.! !

!S2JWebApp methodsFor: 'synchronization' stamp: 'HK 12/6/2010 13:47'!
clientIsBehindWith: aRequest

	^ self class globalResponseId > (self localResponseIdFor: aRequest).! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 18:04'!
cssData 

	^ 'body {
		font-family: Verdana;
		margin: 0px;
		padding: 0px;
	}
	
	#container {
		width: 80%;
		margin: 0px auto;
	}
	
	textarea {
		width: 100%;
		background-color: #F9F7ED;
		border: 1px solid #4096EE;
	}
	
	table {
		width: 100%;
	}
	
	th {
		text-align: left;
		width: 45%;
	}

	tr th:first-child {
		width: 10%;	
	}
	
	.red {
		background-color: #D15600;
	}
	
	.yellow {
		background-color: #FFFF88;
	}
	
	.green {
		background-color: #6BBA70;
	}'.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 11:40'!
handleInputOf: aRequest

	| content |
	content := self postDataOf: aRequest.
	content ifNotNil:
		[self increaseLocalResponseIdFor: aRequest.
		self class updateResponseContentWith: content].
	^ self answerCreated.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 13:43'!
handleRequest: aRequest for: aResource

	aResource = self class applicationPath ifTrue: [ ^ self answerWebsite ].
	aResource = self class xmlPath ifTrue: [ ^ self handleXmlRequest: aRequest ].
	aResource = self class inputPath ifTrue: [ ^ self handleInputOf: aRequest ].
	^ self redirectToHome.
	
	! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/7/2010 14:08'!
handleXmlRequest: aRequest

	^ (self hasNewDataFor: aRequest)
		ifTrue: [ self answerXmlDataTo: aRequest ]
		ifFalse:
			[ self suspendRequestAndExecute:
				[ ^ self handleXmlRequest: aRequest ]].! !

!S2JWebApp methodsFor: 'synchronization' stamp: 'HK 12/6/2010 13:47'!
hasNewDataFor: aRequest

	self class responseContent ifNil: [ ^ false ].
	(self hasSession: aRequest) ifFalse: [ ^ true ].
	^ self clientIsBehindWith: aRequest.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/6/2010 14:23'!
hasSession: aRequest

	^ aRequest cookie notNil and: [ self class sessions includesKey: (aRequest cookie asNumber) ].! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/1/2010 22:00'!
htmlDocumentType

	^ '<!!DOCTYPE html>'.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'SW 12/1/2010 16:08'!
identifierOf: aRequest

	^ aRequest requestLine requestURI identifier.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/7/2010 10:46'!
increaseLocalResponseIdFor: aRequest

	self class sessions at: (aRequest cookie asNumber) put: self class globalResponseId.
	Transcript show: 'Client #', aRequest cookie, ' is now at ', self class globalResponseId asString; cr.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 12:16'!
javascriptCode

	^ '
	var data = null;
	var request = null;
	
	function createXmlRequest() {
		return new XMLHttpRequest();
	}
	
	function poll() {
		request = createXmlRequest();
		request.open("GET", "/xml", true);
		request.onreadystatechange = requestHandler;
		request.send(null);
	}
	
	function requestHandler() {
		if (request.readyState == 4) {
			if (request.status == 200) {
				var xml = request.responseXML.getElementsByTagName("data")[0].firstChild.data;
				log(request.status, decodeURIComponent(xml));
				poll();
			}
			else {
				log(request.status, null);
			}
		}
	}
	
	function send() {
		stop();
		data = document.getElementById("input").value;
		if (data !!= "") {
			request = createXmlRequest();
			request.open("POST", "/put", true);
			request.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
			request.onreadystatechange = responseHandler;
			request.send(encodeURIComponent(data));
		}
	}
	
	function responseHandler() {
		if ((request.readyState == 4) && (request.status == 201)) {
			log(201, data);
			poll();
		}
	}

	function stop() {
		if (request !!= null) {
			request.abort();
			request = null;
		}
	}
	
	function log(httpStatus, content) {
		if ((httpStatus == 200) || (httpStatus == 201)) {
			var evaluatedContent;
			try {
  				evaluatedContent = eval(content);
				prependRow("green", httpStatus, content, evaluatedContent);
			}
			catch(error) {
				prependRow("red", httpStatus, content, error);
			}
		}
		else if (httpStatus == 204) {
			prependRow("yellow", httpStatus, "No content", "");
		}
		else {
			prependRow("yellow", httpStatus, "Client aborted", "");
		} 
	}
		
	function prependRow(cssClass, httpStatus, logText, evalText) {
		var tbody = document.getElementsByTagName("tbody")[0];
		var firstRow = tbody.getElementsByTagName("tr")[0];
		var newRow = row(cssClass, httpStatus, logText, evalText);
		tbody.insertBefore(newRow, firstRow);
	}
	
	function row(cssClass, httpStatus, logText, evalText) {
		var row = document.createElement("tr");
		row.setAttribute("class", cssClass);
		var httpData = document.createElement("td");
		httpData.innerHTML = httpStatus;
		row.appendChild(httpData);
		var logData = document.createElement("td");
		logData.innerHTML = logText;
		row.appendChild(logData);
		var evalData = document.createElement("td");
		evalData.innerHTML = evalText;
		row.appendChild(evalData);
		return row;
	}
	
	function clearLog() {
		var tbody = document.getElementsByTagName("tbody")[0];
		while (tbody.childNodes.length > 0) {
			tbody.removeChild(tbody.childNodes[0]);
		}
	}
	
	function alert(text) {
		return text;
	}'.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/6/2010 13:24'!
localResponseIdFor: aRequest

	^ self class sessions at: (aRequest cookie asNumber).! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 10:50'!
postDataOf: aRequest

	aRequest isPostDataEmpty ifTrue: [ ^ nil ].
	^ aRequest postData keys any.! !

!S2JWebApp methodsFor: 'request handling' stamp: 'HK 12/2/2010 15:23'!
redirectToHome

	| response |
	response := HTTPResponse redirectLink.
	^ response
		location: self class applicationPath;
		yourself.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 10:03'!
renderBody

	^ '<body><div id="container">',
	self renderContent,
	'</div></body></html>'! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 11:34'!
renderContent

	^ '<h3>Post code</h3>
	<p><textarea id="input"></textarea></p>
	<p><input type="button" value="Send data" onclick="send();"></p>
	<h3>Log</h3>
	<p>
	<input type="button" value="Start polling" onclick="poll();">
	<input type="button" value="Stop polling" onclick="stop();">
	<input type="button" value="Clear log" onclick="clearLog();">
	</p>
	<table>
	<thead>
	<tr>
	<th>HTTP</th>
	<th>Log</th>
	<th>Eval</th>
	</tr>
	</thead>
	<tbody>
	</tbody>
	</table>
	</div>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/1/2010 22:00'!
renderHeader

	^ self htmlDocumentType,
	'<html><head><title>',
	self class siteName,
	'</title><script type="text/javascript">',
	self javascriptCode,
	'</script><style type="text/css"><!!--',
	self cssData,
	'--></style></head>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/7/2010 10:47'!
renderWebsite

	^ self renderHeader,
	self renderBody.! !

!S2JWebApp methodsFor: 'session management' stamp: 'HK 12/7/2010 11:04'!
startSessionWith: aResponse

	| randomId |
	[ randomId := 10e10 atRandom ] doWhileTrue:
		[ self class sessions includesKey: randomId ].
	self class sessions at: randomId put: self class defaultResponseId.
	aResponse cookie: randomId asString.
	
	Transcript show: 'Starting session #', randomId asString; cr.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 14:07'!
suspendRequestAndExecute: aBlock
	
	self class isServing ifFalse: [ ^ self answerNoContent ].
	
	self wait.	
	^ aBlock value.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 13:47'!
wait

	(Delay forMilliseconds: self class defaultMillisecondsToWait) wait.! !

!S2JWebApp methodsFor: 'comet' stamp: 'HK 12/7/2010 13:47'!
waitForMilliseconds: milliseconds

	(Delay forMilliseconds: milliseconds) wait.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/6/2010 15:12'!
withEncodedUriComponents: contentString

	| temporaryString |
	temporaryString := contentString.
	
	self class replacementDictionary keysAndValuesDo:
		[ :key :value |
			temporaryString := temporaryString copyReplaceAll: key with: value ].

	^ temporaryString.! !

!S2JWebApp methodsFor: 'convenience' stamp: 'HK 12/2/2010 18:53'!
wrapUpAsXml: content

	^ self xmlDocumentType, '<data>', (self withEncodedUriComponents: content), '</data>'.! !

!S2JWebApp methodsFor: 'rendering' stamp: 'HK 12/2/2010 00:16'!
xmlDocumentType

	^ '<?xml version="1.0"?>'.
! !
